#ifndef CHUNKYPPC_PROTOS_H
#define CHUNKYPPC_PROTOS_H

#include <exec/types.h>
#include <graphics/gfx.h>

#define BIT16 1
#define BIT16_SWAP 2
#define BIT16_ROT 4
#define BIT16_SWAP_ROT 8
#define BIT24 16
#define BIT24_ROT 32
#define BIT32 64
#define BIT32_SWAP 128
#define BIT32_ROT 256
#define BIT32_SWAP_ROT 512
#define BIT32_ROT_REVERSE 1024
#define BIT32_SWAP_ROT_REVERSE 2048
#define BIT8 4096

struct Soff
{
 int x;
 int y;
};

struct Buffers
{
 UBYTE *address;
 UBYTE *mask;
};

 void ChunkyNoffFast(UBYTE *, UBYTE *, int, int, int) ;
 void ChunkyNoffFastest(UBYTE *, UBYTE *, int, int, int);
 void ChunkyNoffNormal(UBYTE *, UBYTE *, int, int, int);
 void ChunkyFast(UBYTE *, UBYTE *, int, int, int, int, int);
 void ChunkyFastest(UBYTE *, UBYTE *, int, int, int, int, int);
 void ChunkyNormal(UBYTE *, UBYTE *, int, int, int, int, int);
 void ChunkyFastFull(UBYTE *, UBYTE *, struct Soff *, struct Soff *, int, struct Soff *, int);
 void ChunkyFastestFull(UBYTE *, UBYTE *, struct Soff *, struct Soff *, int, struct Soff *, int);
 void ChunkyNormalFull(UBYTE *, UBYTE *, struct Soff *, struct Soff *, int, struct Soff *, int);
 void c2p_1(UBYTE *, struct BitMap *, int, int);
 void c2p_2(UBYTE *, UBYTE *, UBYTE *, int);
 void c2p_3(void *, void *, int , int , struct Soff * , int , int);
 void c2p_4(UBYTE *,UBYTE *, UBYTE *, struct Soff *,struct Soff *, struct Soff *);
 void ChunkyNoffFastHT(UBYTE *,UBYTE *,int,int,int,int);
 void ChunkyNoffFastestHT(UBYTE *,UBYTE *,int,int,int,int);
 void ChunkyNoffNormalHT(UBYTE *,UBYTE *,int,int,int,int);
 void ChunkyFastHT(UBYTE *,UBYTE *,struct Soff *,int,int,int,int);
 void ChunkyFastestHT(UBYTE *,UBYTE *,struct Soff *,int,int,int,int);
 void ChunkyNormalHT(UBYTE *,UBYTE *,struct Soff *,int,int,int,int);
 void ChunkyFastFullHT(UBYTE *,UBYTE *,struct Soff *,struct Soff *,struct Soff *,struct Soff *,int);
 void ChunkyFastestFullHT(UBYTE *,UBYTE *,struct Soff *,struct Soff *,struct Soff *, struct Soff *, int);
 void ChunkyNormalFullHT(UBYTE *,UBYTE *,struct Soff *,struct Soff *,struct Soff *,struct Soff *, int);
 void ChunkyNoffMask(struct Buffers *,UBYTE *,int,int,int,int);
 void ChunkyMask(struct Buffers *,UBYTE *,struct Soff *,int,int,int,int);
 void ChunkyMaskFull(struct Buffers *,UBYTE *,struct Soff *, struct Soff *,struct Soff *,struct Soff *, int);
 void c2p_HI( UBYTE *, int, UBYTE *, UBYTE *, UBYTE *, UBYTE *, UBYTE *);

#endif


